/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 02/11/2017
 --------------------------------------------------------
*/
package com.portofolio.service;

import java.util.List;


import java.util.Map;

import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.portofolio.base.BaseServiceImpl;
import com.portofolio.dao.MapLoginUserToProfileDao;
import com.portofolio.dao.ModulAplikasiDao;
import com.portofolio.dto.MapLoginUserToProfileDto;
import com.portofolio.entity.MapLoginUserToProfile;
import com.portofolio.entity.vo.MapLoginUserToProfileId;
import com.portofolio.util.CommonUtil;


@Lazy
@Service
public class MapLoginUserToProfileService extends BaseServiceImpl {

	@Lazy
	@Autowired
	private MapLoginUserToProfileDao mapLoginUserToProfileDao;

	@Lazy
	@Autowired
	private LoginUserService loginUserService;

	@Lazy
	@Autowired
	private RuanganService ruanganService;

	@Lazy
	@Autowired
	private ModulAplikasiDao modulAplikasiDao;

	@Transactional
	public Map<String, Object> save(MapLoginUserToProfileDto mapLoginUserToProfileDto,Long kdUser) {
		result.clear();
		MapLoginUserToProfileId id = new MapLoginUserToProfileId();
		id.setKdProfile(getKdProfile());
		id.setKdModulAplikasi(mapLoginUserToProfileDto.getKdModulAplikasi());
		id.setKdRuangan(mapLoginUserToProfileDto.getKdRuangan());
		id.setKdUser(kdUser);
		MapLoginUserToProfile mapLoginUserToProfile=CommonUtil.findOne(mapLoginUserToProfileDao, id);
		if(CommonUtil.isNullOrEmpty(mapLoginUserToProfile)) {
			mapLoginUserToProfile=new MapLoginUserToProfile();
			BeanUtils.copyProperties(mapLoginUserToProfileDto, mapLoginUserToProfile);
			mapLoginUserToProfile.setStatusEnabled(mapLoginUserToProfileDto.getStatusEnabled());
			mapLoginUserToProfile.setNoRec(generateUuid32());
			mapLoginUserToProfile.setVersion(1);
			mapLoginUserToProfile.setId(id);
			mapLoginUserToProfile = mapLoginUserToProfileDao.save(mapLoginUserToProfile);
			result.put("mapLoginUserToProfile", mapLoginUserToProfile);
			resultCreated();
		}
		
		return result;
	}

	@Transactional
	public Map<String, Object> update(List<MapLoginUserToProfileDto> dto, Long kdUser) {
		result.clear();
		List<MapLoginUserToProfile> tmpList = CommonUtil.createList();
		Boolean status = false;
		for (MapLoginUserToProfileDto mapLoginUserToProfileDto : dto) {
			if (!status) {
				Long jml = mapLoginUserToProfileDao.countIdKdUserByIdKdUserAndIdKdProfile(kdUser, getKdProfile());
				if (jml > 0) {
					mapLoginUserToProfileDao.setStatusEnabledFalse(getKdProfile(),kdUser);
				}
				status = true;
			}
			MapLoginUserToProfile mapLoginUserToProfile = mapLoginUserToProfileDao
					.findOneByIdKdUserAndIdKdProfileAndIdKdModulAplikasiAndIdKdRuangan(
							kdUser, getKdProfile(),
							mapLoginUserToProfileDto.getKdModulAplikasi(), mapLoginUserToProfileDto.getKdRuangan());
			if (CommonUtil.isNotNullOrEmpty(mapLoginUserToProfile)) {
				BeanUtils.copyProperties(mapLoginUserToProfileDto, mapLoginUserToProfile);
				mapLoginUserToProfile.setStatusEnabled(mapLoginUserToProfile.getStatusEnabled());
				mapLoginUserToProfile = mapLoginUserToProfileDao.save(mapLoginUserToProfile);
				tmpList.add(mapLoginUserToProfile);
				
			} else {
				Map<String,Object> data=save(mapLoginUserToProfileDto,kdUser);
				if(CommonUtil.isNullOrEmpty(data)) {
					if(CommonUtil.isNotNullOrEmpty(data.get("mapLoginUserToProfile"))) {
						tmpList.add((MapLoginUserToProfile) data.get("mapLoginUserToProfile"));
					}
				}
			}
		}
		result.put("mapLoginUserToProfile", tmpList);
		resultUpdated();
		return result;
	}

	
	public Map<String, Object> grid(Integer page, Integer limit, String sort, String dir, Long kdUser) {
		result.clear();
		Integer kdProfile = getKdProfile();
		page--;
		PageRequest pageReq = PageRequest.of(page, limit, "desc".equals(sort) ? Direction.DESC : Direction.ASC, dir);
		Page<Map<String, Object>> pageRes;
		if (CommonUtil.isNullOrEmpty(kdUser)) {
			pageRes = mapLoginUserToProfileDao.findAllList(kdProfile, pageReq);
		} else {
			pageRes = mapLoginUserToProfileDao.findAllList(kdProfile, kdUser, pageReq);
		}
		result.put("mapLoginUserToProfile", pageRes.getContent());
		result.put("totalPages", pageRes.getTotalPages());
		result.put("totalRow", pageRes.getTotalElements());
		resultSuccessful();
		return result;
	}

	
	public Map<String, Object> findByKode(Long kode) {
		result.clear();
		List<Map<String, Object>> modul = mapLoginUserToProfileDao.getModulByKodeUser(getKdProfile(), kode);
		List<Map<String, Object>> ruangan = mapLoginUserToProfileDao.getRuanganByKodeUser(getKdProfile(), kode);

		result.put("dataModulAplikasi", modul);
		result.put("dataRuangan", ruangan);
		resultSuccessful();
		return result;

	}



}
